// naumann@stce.rwth-aachen.de

#include <Eigen/Dense>
using VT= Eigen::VectorX<double>;

#include <cassert>
#include <cmath>
#include <iostream>
using namespace std;

double f(double p, double x) {
  assert(x>=0);
  return p*x;
}

double e(double p, VT xobs, VT yobs) {
  assert(xobs.size()==yobs.size());
  double e=0;
  int i=0;
  while (i<xobs.size()) {
    e=e+pow(f(p,xobs(i))-yobs(i),2);
    i=i+1;
  }
  return e;
}

double fit(VT xobs, VT yobs) {
  assert(xobs.size()==yobs.size());
  assert(xobs.size()==1);
  return yobs(0)/xobs(0);
}

int main() {
  double p=0.5, x=0.5, y=0.3;
  int nobs=1;
  VT xobs(nobs), yobs(nobs); 
  xobs(0)=0.5; yobs(0)=0.3;
  cout << "p=" << p << endl;;
  cout << "e=" << e(p,xobs,yobs) << endl;;
  p=fit(xobs,yobs);
  cout << p << endl;;
  cout << "p=" << p << endl;;
  cout << "e=" << e(p,xobs,yobs) << endl;;
  return 0;
}

