// naumann@stce.rwth-aachen.de

#include <Eigen/Dense>
using VT=Eigen::VectorX<double>;

#include <cassert>
#include <cmath>
#include <fstream>
using namespace std;

double model(double p, double x) {
  assert(x>=0);
  return p*x;
}

double e(double p, VT xobs, VT yobs) {
  assert(xobs.size()==yobs.size());
  double e=0;
  int i=0;
  while (i<xobs.size()) {
    e=e+pow(model(p,xobs(i))-yobs(i),2);
    i=i+1;
  }
  return e;
}

int main() {
  double p=-1;
  int nobs=5;
  VT xobs=VT::Random(nobs); 
  xobs=xobs.cwiseProduct(xobs); 
  VT yobs=VT::Random(nobs); 
  ofstream ofs("error");
  int i=0;
  while (i<200) {
    p=p+0.01;
    ofs << p << ' ' << e(p,xobs,yobs) << endl;
    i=i+1;
  }
  return 0;
}
